﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1
{


    public class Compteur_set
    {
        protected int compteur;
        // protected : comme private pour une instance mais comme public pour une classe qui hérite de celle-ci

        public int Compteur
        {
            get { return compteur; }
            set
            {
                if (value >= 0) { compteur = value; }
                else
                {
                    Console.WriteLine("Le compteur doit être positif, la valeur par défaut sera 0");
                    compteur = 0;
                }
            }
        }

        public void Incr()
        {
            Compteur++;
        }

        public void Reset()
        {
            Compteur = 0;
        }

        public void Affichage()
        {
            Console.WriteLine("compteur = " + compteur);
        }
        
    }

    public class Compteur_nonset : Compteur_set
    {

        public new int Compteur
        {
            get { return compteur; }
        }

    }

    class Program
    {
        static void Main(string[] args)
        {

            Compteur_nonset obj1 = new Compteur_nonset();
            Compteur_set obj2 = new Compteur_set();
            obj2.Compteur = 5;
            obj1.Incr();
            obj1.Affichage();
            obj2.Affichage();
        }
    }
}
